﻿$(function () {

    //overrides

    elmahr.onSelectError = function (error) {
        $("#details abbr.timeago").timeago();
        $("#details").dialog("open");
    };

    elmahr.onNewError = function (elem) {
        if (elem.nodeType === 1) {
            $("abbr.timeago", elem).timeago();
            $("abbr.timeagoShort", elem).timeago(true);
            if (!$(elem).hasClass("onReconnect") && !$(elem).hasClass("pulsating")) {
                $(elem).addClass('pulsating');
                $(elem).effect('pulsate', { times: 3 }, 400, function () {
                    $(elem).removeClass('pulsating');
                });
            }
        }
    };

    elmahr.onSelectError = function (error) {
        $("#details abbr.timeago").timeago();
        $("#details").dialog("open");
    };

    elmahr.onGetErrorsResume = function (sourceId) {
        $("#errorsStats").dialog("open");
    };

    elmahr.onGetErrorsResumeDone = function () {
        $("#loadingStats").hide();
        $("#statsLoaded").show();
    };
    
    elmahr.onRememberMe = function (remember) {
        $('#rememberMe').attr('checked', remember);
    };

    elmahr.clearLog = function () {
        $('#log').text('');
    };
    elmahr.onLog = function (message) {
        if (!elmahr.config.log)
            return;
        var css = message.Severity
                ? message.Severity
                : '';
        var msg = message.Date
                ? '[' + message.Date + '] ' + '<span class=\'' + css + '\'>' + message.Message + '</span>'
                : message;
        $('#log').append(msg + '<br/>');
        var height = $('#log')[0].scrollHeight;
        $('#log').scrollTop(height);
    };

    function logIt(message, severity) {
        $('#loading').text(message);

        var now = new Date();
        var utc = new Date(now.getTime() + now.getTimezoneOffset() * 60000);

        elmahr.onLog({
            Message: message,
            Date: utc.format("%d-%n-%y %H:%M:%S"),
            Severity: severity
        });
    }

    elmahr.hideAskForMore = function () {
        $('#askForMoreErrors').hide();
        $('#noMoreErrors').show();
    };

    elmahr.statusConnecting = function () {
        logIt('Connecting...');
    };
    elmahr.statusConnected = function () {
        logIt('Connected, asking for errors...');
    };
    elmahr.statusSendingCommand = function () {
        logIt('Sending command...');
    };
    elmahr.statusStartingHubs = function () {
        logIt('Starting hubs...');
    };
    elmahr.statusRefreshingStats = function () {
        logIt('Refreshing stats...');
    };
    elmahr.statusReceiving = function () {
        logIt('Receiving errors...');
    };

    elmahr.statusShowUI = function () {
        $('#wait').toggle();
        $('#logPad').toggle();
        $('#dashboard').toggle();
    };

    elmahr.startTransfer = function () {
        $('#loading').show();
        elmahr.data.ready = false;
    };
    elmahr.stopTransfer = function () {
        $('#loading').hide();
        elmahr.data.ready = true;
    };

    elmahr.showMessage = function (text, severity) {
        elmahr.onLog(text, severity);
        $('#messages').text(text);
        $('#messages').show();
        window.setTimeout(function () {
            $('#messages').hide();
        }, 5000);
    };

    elmahr.getSortedApplications = function () {
        return $('#applicationBoxes')
            .sortable('serialize', {
                'attribute': 'data-sourceId'
            })
            .replace(/app\[\]\=/g, '')
            .split('&');
    };

    elmahr.toggleBinLoading = function (target, loading) {
        var remove = loading ? 'bin' : 'loading',
            add = loading ? 'loading' : 'bin';
        target.removeClass(remove).addClass(add);
    };

    //knockoutjs bindings

    ko.bindingHandlers.applyTimeAgo = {
        update: function (element) {
            $(element).timeago($(element).hasClass('timeagoShort'));
        }
    };

    ko.bindingHandlers.updateTotal = {
        update: function (elem) {
            if (elmahr.data.ready && !$(elem).hasClass("pulsating")) {
                $(elem).addClass('pulsating');
                $(elem).effect('pulsate', { times: 3 }, 400, function () {
                    $(elem).removeClass('pulsating');
                });
            }
        }
    };

    //init

    elmahr.init();

    //media query surrogate

    var current = 0;
    var disableLinks = false;
    var mediaQuerySurrogate = function () {
        var w = $('#piechart').width();
        if (w !== current) {
            current = w;
            elmahr.refreshStatsFor('pieChart');
        }

        //media query, pair size with css
        var check = document.documentElement.clientWidth < 768;
        if (check !== disableLinks) {
            disableLinks = check;
            elmahr.disablePopup(disableLinks);
        }
    };

    mediaQuerySurrogate();

    $(window).bind('resize', mediaQuerySurrogate);

    //error details

    $("#details").dialog({
        autoOpen: false,
        height: 550,
        width: 670,
        modal: true
    });

    //application boxes

    $("#applicationBoxes")
        .sortable({
            revert: true,
            opacity: 0.6,
            update: function () {
                elmahr.sortApplications(elmahr.getSortedApplications());
            }
        })
        .disableSelection();

    //errors stats

    $("#errorsStats").dialog({
        autoOpen: false,
        height: 550,
        width: 670,
        modal: true,
        close: function () { elmahr.data.selectedApp(null); }
    });

    //hooking events

    $("#toggleDescriptiveText").click(function () {
        $('.intro').toggle();
        return false;
    });

    $("#rememberMe").change(function () {
        elmahr.toggleRememberMe();
    });

    $("#openRememberMeInfo").click(function () {
        $('#rememberMeInfo').toggle();
        return false;
    });

    $("#logBin").click(function () {
        $('#log').text('');
        return false;
    });

});
