﻿(function () {

    //these stats are based on knockoutjs for the rendering part,
    //but it does not have to be like that...

    function ErrorTypeModel(key, value) {

        if (!(this instanceof ErrorTypeModel)) {
            return new ErrorTypeModel(key, value);
        }

        var self = this;

        self.key = key;
        self.value = value;

        var play = 'play',
            pause = 'pause';

        self.feedTitle = function () {
            return elmahr.isErrorTypeBlocked(key)
                       ? 'This error type is paused, press here to resume it'
                       : 'This error type is active, press here to pause it';
        };

        self.toggleErrorType = function (target, e) {
            var type = target.key;

            var t = $(e.currentTarget);
            var c = t.attr('class');
            var n = c === play ? pause : play;

            t.switchClass(c, n, 0);

            elmahr.toggleErrorType(type, n);

            t.attr('title', self.feedTitle());
        };

        this.errorClass = ko.computed(function () {
            return elmahr.isErrorTypeBlocked(key) ? pause : play;
        }, this);

        self.titlePlayPause = ko.computed(self.feedTitle, this);
    }

    elmahr.data.stats = ko.observableArray([]);
    elmahr.data.types = ko.observableArray(null);

    elmahr.extras.stats = function (errors) {

        //error types count
        elmahr.data.types(
           _.chain(errors)
            .groupBy(function (e) { return e.shortType; })
            .reduce(function (acc, e) { return acc + 1; }, 0)
            .value()
            );

        //types stats
        elmahr.data.stats.removeAll();
        _.chain(errors)
            .groupBy(function (q) {
                return q.shortType;
            })
            .map(function (val, key) {
                return new ErrorTypeModel(key, val.length);
            })
            .sortBy(function (kvp) {
                return (10000 - kvp.value) + '/' + kvp.key;
            })
            .each(function (kvp) {
                if (kvp.key)
                    elmahr.data.stats.push(kvp);
            });

    };

} ());